'use strict';

function LambdaComm (name, region) {
  this._functionName = name;
  this._region = region;
  this.aws = require('aws-sdk');
}

LambdaComm.prototype.invoke = function(method, pathParameters, postData) {
  var lambda = new this.aws.Lambda({
    region: this._region
  });
  return lambda.invoke({
    FunctionName: this._functionName,
    Payload: JSON.stringify({
      httpMethod: method,
      postData: postData || {},
      pathParameters: pathParameters || {}
    }, null, 2)
  }, function(error, data) {
    return new Promise(function(resolve, reject) {
      if (error) {
        reject(error);
      } else if(data.Payload && data.Payload.statusCode.charAt(0) == '2') {
        resolve(data);
      } else {
        reject(data);
      }
    });
  });
}

module.exports = LambdaComm